Index: GTP/trunk/Lib/Vis/Preprocessing/src/run_test2
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2653)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2698)
@@ -4,5 +4,5 @@
 
 #COMMAND="./release/preprocessor.exe -preprocessor_quit_on_finish+"
-COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish- -preprocessor_use_gl_renderer+ -preprocessor_evaluate_filter- -samples_per_evaluation=50000000 -samples_per_pass=1000000 -total_samples=20000000 -mutation_use_pass_importance- -mutation_silhouette_search_steps=3 -preprocessor_ray_cast_method=1 -preprocessor_detect_empty_viewspace+ -total_time=140"
+COMMAND="../scripts/preprocessor-debug.sh -preprocessor_quit_on_finish- -preprocessor_use_gl_renderer+ -preprocessor_evaluate_filter- -samples_per_evaluation=50000000 -samples_per_pass=1000000 -total_samples=20000000 -mutation_use_pass_importance- -mutation_silhouette_search_steps=3 -preprocessor_detect_empty_viewspace+ -total_time=140"
 
 #SCENE="../data/vienna/vienna-buildings.x3d;../data/vienna/vienna-roofs.x3d;../data/vienna/vienna-roads.x3d"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2696)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2698)
@@ -1600,6 +1600,8 @@
 SceneGraphLeaf *Preprocessor::RegisterDynamicGeometryWithRayCaster(SceneGraphLeaf *leaf)
 {
-	if (mRayCaster)
-		mRayCaster->AddDynamicObjecs(leaf->mGeometry, leaf->GetTransformation());
+  if (mRayCaster)
+	mRayCaster->AddDynamicObjecs(leaf->mGeometry, leaf->GetTransformation());
+  // $$ JB in order to compile
+  return leaf;
 }
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/default.env
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 2667)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 2698)
@@ -520,16 +520,16 @@
 
 BSP {
-  #termCrit	  auto
-  #termCrit	  auto2
-  termCrit	  adhoc
+  # termCrit	  auto
+  # termCrit	  auto2
+   termCrit	  adhoc
   # For Arena
   #maxDepthAllowed 15
   #maxListLength    8
   # For Vienna
-  #maxDepthAllowed 22
-  #maxListLength    6
+   maxDepthAllowed 22
+   maxListLength    6
   # For Powerplant
-  maxDepthAllowed  27
-  maxListLength     4
+  # maxDepthAllowed  27
+  # maxListLength     4
 }
 
@@ -556,7 +556,7 @@
   # rayCastMethod 0
   # Intel
-  rayCastMethod 1
+  # rayCastMethod 1
   # Havran - 2 - static scene
-  # rayCastMethod 2
+  rayCastMethod 2
   # Havran - 3 - dynamic scene
   # rayCastMethod 3
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Makefile
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2667)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2698)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (2.00a) (Qt 4.1.2) on: út 18. III 16:04:11 2008
+# Generated by qmake (2.00a) (Qt 4.1.2) on: ?t 22. V 11:01:58 2008
 # Project:  preprocessor.pro
 # Template: app
@@ -7,7 +7,7 @@
 #############################################################################
 
-first: release
-install: release-install
-uninstall: release-uninstall
+first: debug
+install: debug-install
+uninstall: debug-uninstall
 MAKEFILE      = Makefile
 QMAKE         = qmake
@@ -27,7 +27,23 @@
 MKDIR         = mkdir
 SUBTARGETS    =  \
-		release \
-		debug
+		debug \
+		release
 
+debug: $(MAKEFILE).Debug FORCE
+	$(MAKE) -f $(MAKEFILE).Debug
+debug-make_default: $(MAKEFILE).Debug FORCE
+	$(MAKE) -f $(MAKEFILE).Debug 
+debug-make_first: $(MAKEFILE).Debug FORCE
+	$(MAKE) -f $(MAKEFILE).Debug first
+debug-all: $(MAKEFILE).Debug FORCE
+	$(MAKE) -f $(MAKEFILE).Debug all
+debug-clean: $(MAKEFILE).Debug FORCE
+	$(MAKE) -f $(MAKEFILE).Debug clean
+debug-distclean: $(MAKEFILE).Debug FORCE
+	$(MAKE) -f $(MAKEFILE).Debug distclean
+debug-install: $(MAKEFILE).Debug FORCE
+	$(MAKE) -f $(MAKEFILE).Debug install
+debug-uninstall: $(MAKEFILE).Debug FORCE
+	$(MAKE) -f $(MAKEFILE).Debug uninstall
 release: $(MAKEFILE).Release FORCE
 	$(MAKE) -f $(MAKEFILE).Release
@@ -46,20 +62,4 @@
 release-uninstall: $(MAKEFILE).Release FORCE
 	$(MAKE) -f $(MAKEFILE).Release uninstall
-debug: $(MAKEFILE).Debug FORCE
-	$(MAKE) -f $(MAKEFILE).Debug
-debug-make_default: $(MAKEFILE).Debug FORCE
-	$(MAKE) -f $(MAKEFILE).Debug 
-debug-make_first: $(MAKEFILE).Debug FORCE
-	$(MAKE) -f $(MAKEFILE).Debug first
-debug-all: $(MAKEFILE).Debug FORCE
-	$(MAKE) -f $(MAKEFILE).Debug all
-debug-clean: $(MAKEFILE).Debug FORCE
-	$(MAKE) -f $(MAKEFILE).Debug clean
-debug-distclean: $(MAKEFILE).Debug FORCE
-	$(MAKE) -f $(MAKEFILE).Debug distclean
-debug-install: $(MAKEFILE).Debug FORCE
-	$(MAKE) -f $(MAKEFILE).Debug install
-debug-uninstall: $(MAKEFILE).Debug FORCE
-	$(MAKE) -f $(MAKEFILE).Debug uninstall
 
 Makefile: preprocessor.pro  C:/Qt/4.1.2/mkspecs/win32-msvc2005\qmake.conf C:/Qt/4.1.2/mkspecs/qconfig.pri \
@@ -68,5 +68,5 @@
 		C:\Qt\4.1.2\mkspecs\features\default_pre.prf \
 		C:\Qt\4.1.2\mkspecs\features\win32\default_pre.prf \
-		C:\Qt\4.1.2\mkspecs\features\release.prf \
+		C:\Qt\4.1.2\mkspecs\features\debug.prf \
 		C:\Qt\4.1.2\mkspecs\features\debug_and_release.prf \
 		C:\Qt\4.1.2\mkspecs\features\default_post.prf \
@@ -89,5 +89,5 @@
 C:\Qt\4.1.2\mkspecs\features\default_pre.prf:
 C:\Qt\4.1.2\mkspecs\features\win32\default_pre.prf:
-C:\Qt\4.1.2\mkspecs\features\release.prf:
+C:\Qt\4.1.2\mkspecs\features\debug.prf:
 C:\Qt\4.1.2\mkspecs\features\debug_and_release.prf:
 C:\Qt\4.1.2\mkspecs\features\default_post.prf:
@@ -109,25 +109,29 @@
 qmake_all: FORCE
 
-make_default: release-make_default debug-make_default FORCE
-make_first: release-make_first debug-make_first FORCE
-all: release-all debug-all FORCE
-clean: release-clean debug-clean FORCE
+make_default: debug-make_default release-make_default FORCE
+make_first: debug-make_first release-make_first FORCE
+all: debug-all release-all FORCE
+clean: debug-clean release-clean FORCE
 	-$(DEL_FILE) "..\bin\release"\preprocessor.exp
-distclean: release-distclean debug-distclean FORCE
+	-$(DEL_FILE) "..\bin\release"\preprocessor.pdb
+	-$(DEL_FILE) "..\bin\release"\preprocessor.ilk
+	-$(DEL_FILE) vc*.pdb
+	-$(DEL_FILE) vc*.idb
+distclean: debug-distclean release-distclean FORCE
 	-$(DEL_FILE) Makefile
 
+debug-mocclean: $(MAKEFILE).Debug
+	$(MAKE) -f $(MAKEFILE).Debug mocclean
 release-mocclean: $(MAKEFILE).Release
 	$(MAKE) -f $(MAKEFILE).Release mocclean
-debug-mocclean: $(MAKEFILE).Debug
-	$(MAKE) -f $(MAKEFILE).Debug mocclean
-mocclean: release-mocclean debug-mocclean
+mocclean: debug-mocclean release-mocclean
 
+debug-mocables: $(MAKEFILE).Debug
+	$(MAKE) -f $(MAKEFILE).Debug mocables
 release-mocables: $(MAKEFILE).Release
 	$(MAKE) -f $(MAKEFILE).Release mocables
-debug-mocables: $(MAKEFILE).Debug
-	$(MAKE) -f $(MAKEFILE).Debug mocables
-mocables: release-mocables debug-mocables
+mocables: debug-mocables release-mocables
 FORCE:
 
+$(MAKEFILE).Debug: Makefile
 $(MAKEFILE).Release: Makefile
-$(MAKEFILE).Debug: Makefile
Index: GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2634)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2698)
@@ -1,4 +1,4 @@
-CONFIG += release
-#CONFIG += debug
+#CONFIG += release
+CONFIG += debug
 CONFIG += console warn_off thread mlrt qt
 
@@ -142,5 +142,5 @@
 SOURCES +=  QtInterface/QtPreprocessorThread.cpp \
 QtInterface/QtGlRenderer.cpp QtInterface/QtGlViewer.cpp 
-SOURCES +=  QtInterface/LogReader.cpp QtInterface/LogWriter.cpp
+SOURCES +=  QtInterface/LogReader.cpp QtInterface/LogWriter.cpp QtInterface/ObjectPlacer.cpp
 } else {
 #SOURCES += BoostPreprocessorThread.cpp 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.cpp	(revision 2696)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.cpp	(revision 2698)
@@ -15,4 +15,6 @@
 #include "Timer/PerfTimer.h"
 #endif
+
+#define USE_HALTON 1
 
 namespace GtpVisibilityPreprocessor {