Index: GTP/trunk/Lib/Vis/Preprocessing/work/plots/plot_sampling
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/work/plots/plot_sampling	(revision 2639)
+++ GTP/trunk/Lib/Vis/Preprocessing/work/plots/plot_sampling	(revision 2699)
@@ -2,4 +2,5 @@
 
 #PREFIX=osp-rss-single
+#PREFIX=sg08-rebuttal-arena-pixel
 PREFIX=osp-vienna
 #PREFIX=osp-pompeii
@@ -23,4 +24,5 @@
 #"
 
+#FILES="`ls $PREFIX*.log`"
 #FILES="../../scripts/stats.log"
 #FILES="`ls $PREFIX*.log`"
@@ -69,4 +71,14 @@
 FILES="osp-vienna-SG08-combined-m8-2.log osp-1e5-r-reference-global.log osp-1e5-r-reference.log"
 
+#FINAL PLOT
+#FILES="osp-1e5-i-mixed-b1-n4l.log osp-1e5-r-reference-global.log osp-1e5-r-reference.log \
+#osp-vienna-SG08-hr-combined-m8-2.log \
+#"
+
+#FILES="osp-vienna-SG08-hr-r-reference.log osp-vienna-SG08-hr-reference-global.log \
+#osp-vienna-SG08-ir-r-reference.log osp-vienna-SG08-ir-reference-global.log \
+#osp-vienna-SG08-gr-r-reference.log osp-vienna-SG08-gr-reference-global.log \
+#"
+
 
 #FINAL TIME PLOT - VIENNA
@@ -148,4 +160,47 @@
 #  "
 # osp-powerplant-SG08b-i-mixed-b1-n4a.log \
+#FILES="osp-PIXEL-1e5-i-mixed-b1-n4l.log \
+#osp-vienna-SG08a-PIXEL-i-mixed-b1-n4l.log \
+#osp-vienna-SG08-PIXEL-i-mixed-b1-n4l.log \
+#osp-vienna-SG08b-PIXEL-i-mixed-b1-n4l.log \
+#"
+#osp-vienna-SG08-PIXEL-i-mixed-b1-n4l.log \
+
+
+#PIXEL ERROR
+#FILES="osp-PIXEL-1e5-i-mixed-b1-n4l.log osp-vienna-SG08a-PIXEL-i-mixed-b1-n4l.log osp-vienna-SG08b-PIXEL-i-mixed-b1-n4l.log osp-vienna-SG08c-PIXEL-i-mixed-b1-n4l.log"
+# FILES="osp-vienna-SG08d-PIXEL-i-mixed-b1-n4l.log \
+# osp-vienna-SG08e-PIXEL-r-reference.log \
+# osp-vienna-SG08d-PIXEL-r-reference-global.log \
+# osp-vienna-SG08e-PIXEL-i-mixed-b1-n4l.log \
+# osp-vienna-SG08e-PIXELRb-i-mixed-b1-n4l.log \
+# osp-vienna-SG08e-PIXELRb-nofilter-i-mixed-b1-n4l.log \
+# osp-vienna-SG08e-PIXELRc-i-mixed-b1-n4l.log \
+# "
+
+#PIXEL ERROR REBUTTAL SG08
+#FILES="osp-PIXEL-1e5-i-mixed-b1-n4l.log osp-vienna-SG08a-PIXEL-i-mixed-b1-n4l.log osp-vienna-SG08b-PIXEL-i-mixed-b1-n4l.log osp-vienna-SG08c-PIXEL-i-mixed-b1-n4l.log"
+# FILES="osp-vienna-SG08e-PIXELRc-r-reference.log \
+# osp-vienna-SG08e-PIXELRc-r-reference-global.log \
+# osp-vienna-SG08e-PIXELRc-i-mixed-b1-n4l-nofilter.log \
+# osp-vienna-SG08e-PIXELRc-i-mixed-b1-n4l.log \
+# "
+
+#FILES="osp-vienna-SG08e-PIXELRd-1e4-r-reference.log \
+#osp-vienna-SG08e-PIXELRd-1e4-r-reference-global.log \
+#osp-vienna-SG08e-PIXELRd-1e4-i-mixed-b1-n4l-nofilter.log \
+#osp-vienna-SG08e-PIXELRd-1e4-i-mixed-b1-n4l.log \
+#"
+
+FILES="osp-arena-SG08e-PIXELRn-1e5-r-reference.log \
+osp-arena-SG08e-PIXELRn-1e5-r-reference-global.log \
+osp-arena-SG08e-PIXELRn-1e5-i-mixed-b1-n4l.log \
+osp-arena-SG08e-PIXELRn-1e5-i-mixed-b1-n4l-filter.log \
+"
+
+#osp-arena-SG08e-PIXELRn-1e4-r-reference.log \
+#osp-arena-SG08e-PIXELRn-1e4-r-reference-global.log \
+#osp-arena-SG08e-PIXELRn-1e4-i-mixed-b1-n4l.log \
+#osp-vienna-SG08e-PIXELRn-1e4-i-mixed-b1-n4l-filter.log \
 
 
@@ -220,4 +275,5 @@
 #./showplot $PREFIX-avgpvsrendererror
 
+$COMMAND3 $STYLE TotalSamples AvgPixelError $FILES
 #$COMMAND1 $STYLE TotalSamples AvgPixelError $FILES
 #./showplot $PREFIX-avgpixelerror
@@ -226,4 +282,5 @@
 ./showplot $PREFIX-avgpixelerror
 
+$COMMAND3 $STYLE TotalSamples MaxPixelError $FILES
 #$COMMAND1 $STYLE TotalSamples MaxPvsRenderError $FILES
 #./showplot $PREFIX-maxpvsrendererror
@@ -232,4 +289,12 @@
 ./showplot $PREFIX-maxpixelerror
 
+$COMMAND3 $STYLE Time AvgPixelError $FILES
+./showplot $PREFIX-avgpixelerrortime
+
+$COMMAND3 $STYLE Time MaxPixelError $FILES
+./showplot $PREFIX-maxpixelerrortime
+
+$COMMAND2 $STYLE TotalSamples ErrorFreeFrames $FILES
+./showplot $PREFIX-errorfreeframes
 #$COMMAND2 $STYLE TotalSamples ErrorFreeFrames $FILES
 #./showplot $PREFIX-errorfreeframes
Index: GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot2
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot2	(revision 2639)
+++ GTP/trunk/Lib/Vis/Preprocessing/work/plots/ps_memory_plot2	(revision 2699)
@@ -14,4 +14,5 @@
 
 
+
 #echo set term x11 > $FILE
 #echo set grid >> $FILE 
@@ -19,4 +20,5 @@
 echo set xlabel \"$2\" >> $FILE 
 echo set ylabel \"$3\" >> $FILE
+#echo set yrange \[0:4000\] >> $FILE
 #echo set yrange \[0:2000\] >> $FILE
 
Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vps.sh
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vps.sh	(revision 2697)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vps.sh	(revision 2699)
@@ -11,4 +11,6 @@
 echo "starting $TARGET version"
 
+#SCENE=../data/Arena/arena-high-lods.obj
+#VIEWCELLS=../data/Arena/arena-high-lods-5000-viewcells.xml.gz
 #SCENE=../data/vienna/vienna_cropped.obj
 #SCENE=../data/roofs2.obj
@@ -16,7 +18,9 @@
 SCENE=../data/vienna/vienna_rep.obj
 
-VIEWCELLS=../data/vienna/vienna_cropped-gradient-viewcells.xml.gz 
+#SCENE=../data/vienna/vienna_cropped.obj
+#VIEWCELLS=../data/vienna/vienna_cropped-gradient-viewcells.xml.gz 
 VIEWPOINTS=../data/vienna/testwalk.vp
 
+#LOG_PREFIX=../src/SG08/rebut-arena-pixel2
 LOG_PREFIX=../src/SG08/try_100_real
 #LOG_PREFIX=../src/SG08/city_full_100
@@ -40,4 +44,5 @@
 -gvs_min_contribution=50 \
 -gvs_per_viewcell=true \
+-preprocessor_detect_empty_viewspace+ -kd_pvs_area=1e-5 -view_cells_use_kd_pvs+ -af_use_kd_pvs+ \
 -gvs_stats=$LOG_PREFIX-gvsStats.log \
 -view_cells_filename=$VIEWCELLS \
Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_arena.sh
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_arena.sh	(revision 2633)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_arena.sh	(revision 2699)
@@ -6,5 +6,5 @@
 #TARGET=debug
 TARGET=release
-COMMAND="../bin/$TARGET/Preprocessor.exe -preprocessor_quit_on_finish- -preprocessor_use_gl_renderer+ -preprocessor_evaluate_filter- -samples_per_evaluation=5000000 -samples_per_pass=500000"
+COMMAND="../bin/$TARGET/Preprocessor.exe -preprocessor_quit_on_finish- -preprocessor_use_gl_renderer+ -preprocessor_evaluate_filter- -samples_per_evaluation=5000000 -samples_per_pass=500000 -preprocessor_use_kd_pvs+"
 
 echo "starting $TARGET version"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/run_test2
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2698)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2699)
@@ -4,5 +4,5 @@
 
 #COMMAND="./release/preprocessor.exe -preprocessor_quit_on_finish+"
-COMMAND="../scripts/preprocessor-debug.sh -preprocessor_quit_on_finish- -preprocessor_use_gl_renderer+ -preprocessor_evaluate_filter- -samples_per_evaluation=50000000 -samples_per_pass=1000000 -total_samples=20000000 -mutation_use_pass_importance- -mutation_silhouette_search_steps=3 -preprocessor_detect_empty_viewspace+ -total_time=140"
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish- -preprocessor_use_gl_renderer+ -preprocessor_evaluate_filter- -samples_per_evaluation=50000000 -samples_per_pass=1000000 -total_samples=20000000 -mutation_use_pass_importance- -mutation_silhouette_search_steps=3 -preprocessor_detect_empty_viewspace+ -total_time=140"
 
 #SCENE="../data/vienna/vienna-buildings.x3d;../data/vienna/vienna-roofs.x3d;../data/vienna/vienna-roads.x3d"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2698)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2699)
@@ -527,5 +527,5 @@
 		cout << "finished loading" << endl;
 	}
-
+	
 	return result;
 }
@@ -1037,32 +1037,44 @@
 	GetIntValue("Preprocessor.rayCastMethod", rayCastMethod);
 
-#ifdef USE_HAVRAN_RAYCASTER
-
+  // first buildup the tree for havran ray caster if it is used
   if ((rayCastMethod == 2) || (rayCastMethod == 3)) 
-  {
-	  HavranRayCaster *hr = 0;
-
-	  if (rayCastMethod == 3)
-		  hr = reinterpret_cast<HavranDynRayCaster*>(mRayCaster);
-	  else
-		  hr = reinterpret_cast<HavranRayCaster*>(mRayCaster);
-
-	  string ktbFilename = internKdTree;
-	  int l = (int)ktbFilename.length();
-	  ktbFilename[l-1] = 't';
-	  ktbFilename[l-2] = 'b';
-	  ktbFilename[l-3] = 'k';
-
-	  cout << "Trying to load tree from file " << ktbFilename << endl;
-	  if (hr->ImportBinTree(ktbFilename, this->mObjects)) {
-		  cout << "Loading failed - building kd-tree" << endl;
-		  hr->Build(this->mObjects);
-		  cout << "Exporting kd-tree to file " << ktbFilename << endl;
-		  hr->ExportBinTree(ktbFilename);
-	  }
-	  else
-		  cout << " done." << endl;
-  }
-#endif
+	{
+ 	  HavranRayCaster *hr = 0;
+
+ 	  if (rayCastMethod == 3)
+		hr = reinterpret_cast<HavranDynRayCaster*>(mRayCaster);
+ 	  else
+		hr = reinterpret_cast<HavranRayCaster*>(mRayCaster);
+	  
+	  hr->Build(this->mObjects);
+	}
+  
+// #ifdef USE_HAVRAN_RAYCASTER
+//   if ((rayCastMethod == 2) || (rayCastMethod == 3)) 
+//   {
+// 	  HavranRayCaster *hr = 0;
+
+// 	  if (rayCastMethod == 3)
+// 		  hr = reinterpret_cast<HavranDynRayCaster*>(mRayCaster);
+// 	  else
+// 		  hr = reinterpret_cast<HavranRayCaster*>(mRayCaster);
+
+// 	  string ktbFilename = internKdTree;
+// 	  int l = (int)ktbFilename.length();
+// 	  ktbFilename[l-1] = 't';
+// 	  ktbFilename[l-2] = 'b';
+// 	  ktbFilename[l-3] = 'k';
+
+// 	  cout << "Trying to load tree from file " << ktbFilename << endl;
+// 	  if (hr->ImportBinTree(ktbFilename, this->mObjects)) {
+// 		  cout << "Loading failed - building kd-tree" << endl;
+// 		  hr->Build(this->mObjects);
+// 		  cout << "Exporting kd-tree to file " << ktbFilename << endl;
+// 		  hr->ExportBinTree(ktbFilename);
+// 	  }
+// 	  else
+// 		  cout << " done." << endl;
+//   }
+// #endif
 
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/common.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/common.h	(revision 2678)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/common.h	(revision 2699)
@@ -24,5 +24,5 @@
 
 #define DYNAMIC_OBJECTS_HACK 1
-#define USE_HAVRAN_RAYCASTER 0
+#define USE_HAVRAN_RAYCASTER 1
 
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/HavranRayCaster.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/HavranRayCaster.cpp	(revision 2686)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/HavranRayCaster.cpp	(revision 2699)
@@ -60,8 +60,9 @@
   Environment::GetSingleton()->GetStringValue("Scene.filename", buff);
   string filename(buff);
+
   const string kdfile = ReplaceSuffix(filename, ".obj", ".kdh");
 
   if (!ImportBinTree(kdfile, objlist)) {
-        cout << "\nKd-tree for Havran ray caster imported."<<endl<<flush;
+	cout << "\nKd-tree for Havran ray caster imported."<<endl<<flush;
   }
   else {
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Makefile
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2698)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2699)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (2.00a) (Qt 4.1.2) on: ?t 22. V 11:01:58 2008
+# Generated by qmake (2.00a) (Qt 4.1.2) on: pá 23. V 13:41:28 2008
 # Project:  preprocessor.pro
 # Template: app
@@ -7,7 +7,7 @@
 #############################################################################
 
-first: debug
-install: debug-install
-uninstall: debug-uninstall
+first: release
+install: release-install
+uninstall: release-uninstall
 MAKEFILE      = Makefile
 QMAKE         = qmake
@@ -27,7 +27,23 @@
 MKDIR         = mkdir
 SUBTARGETS    =  \
-		debug \
-		release
+		release \
+		debug
 
+release: $(MAKEFILE).Release FORCE
+	$(MAKE) -f $(MAKEFILE).Release
+release-make_default: $(MAKEFILE).Release FORCE
+	$(MAKE) -f $(MAKEFILE).Release 
+release-make_first: $(MAKEFILE).Release FORCE
+	$(MAKE) -f $(MAKEFILE).Release first
+release-all: $(MAKEFILE).Release FORCE
+	$(MAKE) -f $(MAKEFILE).Release all
+release-clean: $(MAKEFILE).Release FORCE
+	$(MAKE) -f $(MAKEFILE).Release clean
+release-distclean: $(MAKEFILE).Release FORCE
+	$(MAKE) -f $(MAKEFILE).Release distclean
+release-install: $(MAKEFILE).Release FORCE
+	$(MAKE) -f $(MAKEFILE).Release install
+release-uninstall: $(MAKEFILE).Release FORCE
+	$(MAKE) -f $(MAKEFILE).Release uninstall
 debug: $(MAKEFILE).Debug FORCE
 	$(MAKE) -f $(MAKEFILE).Debug
@@ -46,27 +62,11 @@
 debug-uninstall: $(MAKEFILE).Debug FORCE
 	$(MAKE) -f $(MAKEFILE).Debug uninstall
-release: $(MAKEFILE).Release FORCE
-	$(MAKE) -f $(MAKEFILE).Release
-release-make_default: $(MAKEFILE).Release FORCE
-	$(MAKE) -f $(MAKEFILE).Release 
-release-make_first: $(MAKEFILE).Release FORCE
-	$(MAKE) -f $(MAKEFILE).Release first
-release-all: $(MAKEFILE).Release FORCE
-	$(MAKE) -f $(MAKEFILE).Release all
-release-clean: $(MAKEFILE).Release FORCE
-	$(MAKE) -f $(MAKEFILE).Release clean
-release-distclean: $(MAKEFILE).Release FORCE
-	$(MAKE) -f $(MAKEFILE).Release distclean
-release-install: $(MAKEFILE).Release FORCE
-	$(MAKE) -f $(MAKEFILE).Release install
-release-uninstall: $(MAKEFILE).Release FORCE
-	$(MAKE) -f $(MAKEFILE).Release uninstall
 
-Makefile: preprocessor.pro  C:/Qt/4.1.2/mkspecs/win32-msvc2005\qmake.conf C:/Qt/4.1.2/mkspecs/qconfig.pri \
+Makefile: preprocessor.pro  C:/Qt/4.1.2/mkspecs/win32-msvc.net\qmake.conf C:/Qt/4.1.2/mkspecs/qconfig.pri \
 		C:\Qt\4.1.2\mkspecs\features\qt_config.prf \
 		C:\Qt\4.1.2\mkspecs\features\exclusive_builds.prf \
 		C:\Qt\4.1.2\mkspecs\features\default_pre.prf \
 		C:\Qt\4.1.2\mkspecs\features\win32\default_pre.prf \
-		C:\Qt\4.1.2\mkspecs\features\debug.prf \
+		C:\Qt\4.1.2\mkspecs\features\release.prf \
 		C:\Qt\4.1.2\mkspecs\features\debug_and_release.prf \
 		C:\Qt\4.1.2\mkspecs\features\default_post.prf \
@@ -89,5 +89,5 @@
 C:\Qt\4.1.2\mkspecs\features\default_pre.prf:
 C:\Qt\4.1.2\mkspecs\features\win32\default_pre.prf:
-C:\Qt\4.1.2\mkspecs\features\debug.prf:
+C:\Qt\4.1.2\mkspecs\features\release.prf:
 C:\Qt\4.1.2\mkspecs\features\debug_and_release.prf:
 C:\Qt\4.1.2\mkspecs\features\default_post.prf:
@@ -109,29 +109,25 @@
 qmake_all: FORCE
 
-make_default: debug-make_default release-make_default FORCE
-make_first: debug-make_first release-make_first FORCE
-all: debug-all release-all FORCE
-clean: debug-clean release-clean FORCE
+make_default: release-make_default debug-make_default FORCE
+make_first: release-make_first debug-make_first FORCE
+all: release-all debug-all FORCE
+clean: release-clean debug-clean FORCE
 	-$(DEL_FILE) "..\bin\release"\preprocessor.exp
-	-$(DEL_FILE) "..\bin\release"\preprocessor.pdb
-	-$(DEL_FILE) "..\bin\release"\preprocessor.ilk
-	-$(DEL_FILE) vc*.pdb
-	-$(DEL_FILE) vc*.idb
-distclean: debug-distclean release-distclean FORCE
+distclean: release-distclean debug-distclean FORCE
 	-$(DEL_FILE) Makefile
 
+release-mocclean: $(MAKEFILE).Release
+	$(MAKE) -f $(MAKEFILE).Release mocclean
 debug-mocclean: $(MAKEFILE).Debug
 	$(MAKE) -f $(MAKEFILE).Debug mocclean
-release-mocclean: $(MAKEFILE).Release
-	$(MAKE) -f $(MAKEFILE).Release mocclean
-mocclean: debug-mocclean release-mocclean
+mocclean: release-mocclean debug-mocclean
 
+release-mocables: $(MAKEFILE).Release
+	$(MAKE) -f $(MAKEFILE).Release mocables
 debug-mocables: $(MAKEFILE).Debug
 	$(MAKE) -f $(MAKEFILE).Debug mocables
-release-mocables: $(MAKEFILE).Release
-	$(MAKE) -f $(MAKEFILE).Release mocables
-mocables: debug-mocables release-mocables
+mocables: release-mocables debug-mocables
 FORCE:
 
+$(MAKEFILE).Release: Makefile
 $(MAKEFILE).Debug: Makefile
-$(MAKEFILE).Release: Makefile
Index: GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2695)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2699)
@@ -222,5 +222,4 @@
 	////////////
 	//-- initialize external ray caster
-
 	if (preprocessor->LoadInternKdTree(internKdTree))
 	{
@@ -234,4 +233,6 @@
 	}
 
+	
+	
 	// export objects as obj
 	if (preprocessor->mExportObj)
Index: GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2698)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2699)
@@ -1,4 +1,4 @@
-#CONFIG += release
-CONFIG += debug
+CONFIG += release
+#CONFIG += debug
 CONFIG += console warn_off thread mlrt qt
 