Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2702)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2703)
@@ -662,5 +662,5 @@
 		cout << "loading objects from " << buf << endl;
 
-		// load scene objects used as pvs entries
+		// load scene objects which are the entities used as pvs entries
 		ObjectContainer pvsObjects;
 		if (0) LoadObjects(buf, pvsObjects, mObjects);
@@ -1598,8 +1598,8 @@
 	mSceneGraph->GetRoot()->mChildren.push_back(leaf);
 
-  if (mRayCaster)
-	mRayCaster->AddDynamicObjecs(leaf->mGeometry, leaf->GetTransformation());
-  // $$ JB in order to compile
-  return leaf;
+	if (mRayCaster)
+		mRayCaster->AddDynamicObjecs(leaf->mGeometry, leaf->GetTransformation());
+	// $$ JB in order to compile
+	//return leaf;
 }
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2702)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2703)
@@ -835,7 +835,5 @@
 		swap(p->mDynamicObjects[idx], p->mDynamicObjects.back());
 		p->mDynamicObjects.pop_back();
-		/*if (mCurrentDynamicObjectIdx >= 0) {
-		preprocessor->ScheduleUpdateDynamicObjects();
-		}*/
+		//preprocessor->ScheduleUpdateDynamicObjects();
 	}
 }
@@ -1113,6 +1111,4 @@
 	mUseSpatialFilter = tmp;
 
-	//mLogWriter = new LogWriter("myfile.out");
-
 	mShowRenderCost = false;
 	mShowPvsSizes = false;
@@ -1127,5 +1123,4 @@
 	mShowWeightedTriangles = false;
 	mShowDistribution = 15;
-	mCurrentDynamicObjectIdx = -1;
 
 	mSpatialFilterSize = 0.01;
@@ -1156,5 +1151,5 @@
 	connect(mControlWidget, SIGNAL(ComputeGVS(void)), this, SLOT(ComputeGVS(void)));
 	connect(mControlWidget, SIGNAL(ReplayViewPoints(void)), this, SLOT(ReplayViewPoints(void)));
-	connect(mControlWidget, SIGNAL(LoadObject(void)), this, SLOT(LoadObject(void)));
+	connect(mControlWidget, SIGNAL(NextObject(void)), this, SLOT(NextObject(void)));
 
 	connect(mControlWidget, SIGNAL(SetSceneCut(int)), this, SLOT(SetSceneCut(int)));
@@ -1215,4 +1210,6 @@
 	
 	mControlWidget->show();
+
+	LoadObjects();
 }
 
@@ -1266,12 +1263,22 @@
 
 
-void QtGlRendererWidget::LoadObject()
-{
-	string filename("../data/teapot.bn");
-	//string filename("../data/cube.obj");
-	
-	cout << "Loading model << " << filename << endl;
-
-	++ mCurrentDynamicObjectIdx;
+void QtGlRendererWidget::LoadObjects()
+{
+	LoadObject("../data/teapot.bn");
+	LoadObject("../data/bunny.bn");
+	LoadObject("../data/horse.bn");
+}
+
+
+void QtGlRendererWidget::NextObject()
+{
+	cout << "*********\n**** next object!!!!!!!!!!!! " << endl;
+	mPlacer->NextObject();	
+}
+
+
+void QtGlRendererWidget::LoadObject(const string &filename)
+{
+	cout << "Loading model " << filename << endl;
 
 	SceneGraphLeaf *leaf = 
@@ -1286,5 +1293,5 @@
 		cerr << "Loading failed" << endl;
 	
-    updateGL();
+    //updateGL();
 }
 
@@ -2378,5 +2385,6 @@
 	button = new QPushButton("Load object", vbox);
 	vbox->layout()->addWidget(button);
-	connect(button, SIGNAL(clicked()), SIGNAL(LoadObject()));
+	connect(button, SIGNAL(clicked()), SIGNAL(NextObject()));
+	//connect(button, SIGNAL(clicked()), SIGNAL(LoadObject()));
 
 	/*cb = new QCheckBox("Stats", vbox);
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.h	(revision 2702)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.h	(revision 2703)
@@ -119,5 +119,6 @@
   void StoreStatistics();
   void ComputeGVS();
-  void LoadObject();
+  //void LoadObjects();
+  void NextObject();
   void UpdateAllPvs();
   void SetViewCellGranularity(int);
@@ -217,6 +218,4 @@
 	int mShowDistribution;
 
-	int mCurrentDynamicObjectIdx;
-
 	bool mReplayMode;
 
@@ -327,4 +326,6 @@
 	int FindDynamicObject(float x, float y);
 
+	void LoadObjects();
+	void LoadObject(const std::string &filename);
 
 public slots:
@@ -340,5 +341,6 @@
 	void StoreStatistics();
 	
-	void LoadObject();
+	//void LoadObject();
+	void NextObject();
 
 	void SetRenderErrors(bool b) {