Index: /GTP/trunk/Lib/Vis/Preprocessing/src/run_test2
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2701)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2708)
@@ -4,5 +4,5 @@
 
 #COMMAND="./release/preprocessor.exe -preprocessor_quit_on_finish+"
-COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish- -preprocessor_use_gl_renderer+ -preprocessor_evaluate_filter- -samples_per_evaluation=50000000 -samples_per_pass=1000000 -total_samples=20000000 -mutation_use_pass_importance- -mutation_silhouette_search_steps=3 -preprocessor_detect_empty_viewspace+ -total_time=140"
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish- -preprocessor_use_gl_renderer+ -preprocessor_evaluate_filter- -samples_per_evaluation=50000000 -samples_per_pass=100000 -total_samples=20000000 -mutation_use_pass_importance- -mutation_silhouette_search_steps=3 -preprocessor_detect_empty_viewspace+ -total_time=1400"
 
 #SCENE="../data/vienna/vienna-buildings.x3d;../data/vienna/vienna-roofs.x3d;../data/vienna/vienna-roads.x3d"
@@ -59,5 +59,5 @@
 
 
-$COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
 -rss_distributions=mutation+object_direction+spatial \
 -mutation_silhouette_prob=0.5 \
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2707)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2708)
@@ -1667,5 +1667,6 @@
   Intersectable *inter = leaf->GetIntersectable();
   int removedEntries = 0;
-  
+  CSeparatingAxisTester shadowVolume;
+
   // now search for pvss which contained any mailed node
   for (vit = mViewCellsManager->GetViewCells().begin(); vit != vit_end; ++ vit) {
@@ -1675,5 +1676,4 @@
 	  removedEntries += pvs.GetSize();
 	} else {
-	  CSeparatingAxisTester shadowVolume;
 	  
 	  //	cout<<(*vit)->GetBox()<<" "<<box<<endl;
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/default.env
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 2700)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 2708)
@@ -41,4 +41,5 @@
 
 Preprocessor {
+	useVbos false
 	totalSamples 250000000
 #	totalSamples 2000000
@@ -556,7 +557,7 @@
   # rayCastMethod 0
   # Intel
-  # rayCastMethod 1
+  rayCastMethod 1
   # Havran - 2 - static scene
-  rayCastMethod 2
+  # rayCastMethod 2
   # Havran - 3 - dynamic scene
   # rayCastMethod 3
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2707)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2708)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (2.00a) (Qt 4.1.2) on: so 24. V 22:09:30 2008
+# Generated by qmake (2.00a) (Qt 4.1.2) on: so 24. V 23:11:10 2008
 # Project:  preprocessor.pro
 # Template: app
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/SepPlanesBox3.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/SepPlanesBox3.h	(revision 2707)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/SepPlanesBox3.h	(revision 2708)
@@ -25,5 +25,5 @@
   // the number of separating planes
   int cntPlanes;
-  Plane3 planes[18];
+  Plane3 planes[180];
   AxisAlignedBox3 origBox;
   AxisAlignedBox3 shadBox;
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2707)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2708)
@@ -64,5 +64,6 @@
 
 CONFIG(debug) {
-win32:LIBS += xerces-c_2D.lib 
+win32:LIBS += xerces-c_2.lib 
+#win32:LIBS += xerces-c_2D.lib 
 }
 