Index: /GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vps.sh
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vps.sh	(revision 2702)
+++ /GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vps.sh	(revision 2716)
@@ -14,6 +14,6 @@
 #VIEWCELLS=../data/Arena/arena-high-lods-5000-viewcells.xml.gz
 #SCENE=../data/vienna/vienna_cropped.obj
-SCENE=../data/roofs_new.obj
-#SCENE=../data/vienna/city_full_hp.obj
+#SCENE=../data/roofs_new.obj
+SCENE=../data/vienna/city_full_hp.obj
 #SCENE=../data/vienna/vienna_rep.obj
 
@@ -23,6 +23,6 @@
 
 #LOG_PREFIX=../src/SG08/rebut-arena-pixel2
-LOG_PREFIX=../src/SG08/try_100_real
-#LOG_PREFIX=../src/SG08/city_full_100
+#LOG_PREFIX=../src/SG08/full
+LOG_PREFIX=../src/SG08/city_full
 
 ENVIRONMENT=gvs.env
@@ -41,8 +41,11 @@
 -gvs_samples_per_pass=1000000 \
 -gvs_initial_samples=16 \
--gvs_max_viewcells=2000 \
--gvs_min_contribution=50 \
+-gvs_max_viewcells=5000 \
+-gvs_min_contribution=500 \
 -gvs_per_viewcell=true \
--preprocessor_detect_empty_viewspace+ -kd_pvs_area=1e-5 -view_cells_use_kd_pvs+ -af_use_kd_pvs+ \
+-preprocessor_detect_empty_viewspace+ \
+-kd_pvs_area=1e-4 \
+-view_cells_use_kd_pvs+ \
+-af_use_kd_pvs+ \
 -gvs_stats=$LOG_PREFIX-gvsStats.log \
 -view_cells_filename=$VIEWCELLS \
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2715)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2716)
@@ -1755,51 +1755,54 @@
 	{
 
-	  // delete ALL dynamic stuff and rebuild using the new trafos
-	  preprocessor->mRayCaster->DeleteDynamicObjects();
-	  
+		// delete ALL dynamic stuff and rebuild using the new trafos
+		preprocessor->mRayCaster->DeleteDynamicObjects();
+
 #define MULTIPLE_OBJECTS 1
 
 #if MULTIPLE_OBJECTS 
-	  static ObjectContainer objects;
-	  
-	  CLEAR_CONTAINER(objects);
-	  
-	  for (size_t i = 0; i < mDynamicObjects.size(); ++ i) {
-		SceneGraphLeaf *l = mDynamicObjects[i];
-		for (int j=0; j < l->mGeometry.size(); j++) {
-		  if (l->mGeometry[j]->Type() == Intersectable::TRIANGLE_INTERSECTABLE) {
-			Triangle3 t(((TriangleIntersectable *)l->mGeometry[j])->GetItem());
-			t.ApplyTransformation(l->GetTransformation());
-			TriangleIntersectable *to = new TriangleIntersectable(t);
-			to->SetId(l->GetIntersectable()->GetId());
-
-			objects.push_back(to);
-		  }
-		}
-	  }
-	  mRayCaster->AddDynamicObjecs(objects, IdentityMatrix());
+		static ObjectContainer objects;
+
+		CLEAR_CONTAINER(objects);
+
+		for (size_t i = 0; i < mDynamicObjects.size(); ++ i) 
+		{
+			SceneGraphLeaf *l = mDynamicObjects[i];
+
+			for (size_t j=0; j < l->mGeometry.size(); j++) 
+			{
+				if (l->mGeometry[j]->Type() == Intersectable::TRIANGLE_INTERSECTABLE) 
+				{
+					Triangle3 t(((TriangleIntersectable *)l->mGeometry[j])->GetItem());
+					t.ApplyTransformation(l->GetTransformation());
+					TriangleIntersectable *to = new TriangleIntersectable(t);
+					to->SetId(l->GetIntersectable()->GetId());
+					objects.push_back(to);
+				}
+			}
+		}
+
+		mRayCaster->AddDynamicObjecs(objects, IdentityMatrix());
 #endif	  
 
-	  SceneGraphLeaf *toUpdate = NULL;
-	  
-	  for (size_t i = 0; i < mDynamicObjects.size(); ++ i) 
-	  {
-		  SceneGraphLeaf *l = mDynamicObjects[i];
+		SceneGraphLeaf *toUpdate = NULL;
+
+		for (size_t i = 0; i < mDynamicObjects.size(); ++ i) 
+		{
+			SceneGraphLeaf *l = mDynamicObjects[i];
 
 #if  !MULTIPLE_OBJECTS
-		  PrepareObjectsForRayCaster(l);
+			PrepareObjectsForRayCaster(l);
 #endif
 
-		  if (l->HasChanged())
-		  {
-			  cout<<"Updating affected PVSs..."<<endl;
-			  preprocessor->ObjectMoved(l);
-			  cout<<"done."<<endl;	
-			  l->SetHasChanged(false);
-		  }
-	  }
-
-	  mUpdateDynamicObjects = false;
-	  
+			if (l->HasChanged())
+			{
+				cout<<"Updating affected PVSs..."<<endl;
+				preprocessor->ObjectMoved(l);
+				cout<<"done."<<endl;	
+				l->SetHasChanged(false);
+			}
+		}
+		
+		mUpdateDynamicObjects = false;
 	}
 }
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2715)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2716)
@@ -246,13 +246,13 @@
 
 		// mat_specular and mat_shininess are NOT default values
-	GLfloat mat_ambient[] = {0.5f, 0.5f, 0.5f, 1.0f};
-	GLfloat mat_diffuse[] = {1.0f, 1.0f, 1.0f, 1.0f};
-	GLfloat mat_specular[] = {0.3f, 0.3f, 0.3f, 1.0f};
-	GLfloat mat_shininess[] = {1.0f};
-
-	glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
-	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
-	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
-	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
+		GLfloat mat_ambient[] = {0.5f, 0.5f, 0.5f, 1.0f};
+		GLfloat mat_diffuse[] = {1.0f, 1.0f, 1.0f, 1.0f};
+		GLfloat mat_specular[] = {0.3f, 0.3f, 0.3f, 1.0f};
+		GLfloat mat_shininess[] = {1.0f};
+
+		glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
+		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
+		glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
+		glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
 
 		GLfloat light_ambient[] = {0.3, 0.3, 0.3, 1.0};
@@ -288,6 +288,6 @@
 	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
 
-	glColor3f(0.6f, 0.6f, 0.6f);
-	//glColor3f(0, 1, 0);
+	//glColor3f(0.6f, 0.6f, 0.6f);
+	glColor3f(0, 1, 0);
 
 	glDepthFunc(GL_LESS);
@@ -342,11 +342,9 @@
 
 	// some error happened
-	if (1) // pixelCount > pixelThres) 
+	if (pixelCount > pixelThres) 
 	{
 		cout << "f " << mFrame << " id " << viewcell->GetId() << " pvs " << pvsSize 
 			 << " e " << pixelCount << " vp " << mViewPoint << " vd " << mViewDirection << endl;
 	
-		format().setSampleBuffers(true);
-		cout << "here3 " << format().sampleBuffers() << endl;
 		if (mSnapErrorFrames) 
 		{
@@ -358,7 +356,7 @@
 
 			char filename[256];
-			sprintf(filename, "error-frame-%04d-%05d.bmp", pass, mFrame);
+			//sprintf(filename, "error-frame-%04d-%05d.bmp", pass, mFrame);
 			//sprintf(filename, "error-frame-%05d-%0.5f.png", mFrame, pErrorPixels);
-			//sprintf_s(filename, "error-frame-%05d-%04d-%08d.png", mFrame, viewcell->GetId(), pixelCount);
+			sprintf_s(filename, "error-frame-%05d-%04d-%08d.png", mFrame, viewcell->GetId(), pixelCount);
 
 			QImage im = toImage();
@@ -366,7 +364,5 @@
 			QString qstr(str.c_str());
 
-			//im.save(qstr, "PNG");
-			// use bmp for lossless storage (for video)
-			im.save(qstr, "BMP");
+			im.save(qstr, "PNG");
 
 			if (0)