Index: GTP/trunk/Lib/Vis/Preprocessing/src/run_test2
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2713)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2719)
@@ -4,5 +4,5 @@
 
 #COMMAND="./release/preprocessor.exe -preprocessor_quit_on_finish+"
-COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish- -preprocessor_use_gl_renderer+ -preprocessor_evaluate_filter- -samples_per_evaluation=50000000 -samples_per_pass=300000 -total_samples=20000000 -mutation_use_pass_importance- -mutation_silhouette_search_steps=3 -preprocessor_detect_empty_viewspace+ -total_time=1400"
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish- -preprocessor_use_gl_renderer+ -preprocessor_evaluate_filter- -samples_per_evaluation=50000000 -samples_per_pass=300000 -total_samples=20000000 -mutation_use_pass_importance- -mutation_silhouette_search_steps=3 -preprocessor_detect_empty_viewspace+ -total_time=60  -preprocessor_ray_cast_method=1 -kd_pvs_area=1e-4"
 
 #SCENE="../data/vienna/vienna-buildings.x3d;../data/vienna/vienna-roofs.x3d;../data/vienna/vienna-roads.x3d"
@@ -29,12 +29,12 @@
 #VIEWCELLS=../data/test1/test-viewcells.xml
 
-#SCENE=../data/Arena/arena-high-lods.obj
-#VIEWCELLS=../data/Arena/arena-high-lods-5000-viewcells.xml.gz
+SCENE=../data/Arena/arena-high-lods.obj
+VIEWCELLS=../data/Arena/arena-high-lods-5000-viewcells.xml.gz
 #VIEWCELLS=../data/Arena/viewcells-5000.xml.gz
 #VIEWCELLS=../data/Arena/arena-high-lods-57000-viewcells.xml.gz
 
 
- SCENE=../data/vienna/vienna_cropped.obj
- VIEWCELLS=../data/vienna/vienna_cropped-gradient-viewcells.xml.gz
+# SCENE=../data/vienna/vienna_cropped.obj
+# VIEWCELLS=../data/vienna/vienna_cropped-gradient-viewcells.xml.gz
 #VIEWCELLS=../data/vienna/vienna_cropped-20000-viewcells.xml.gz
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2717)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2719)
@@ -20,4 +20,5 @@
 #include "ObjectPlacer.h"
 
+#define TEASER 1
 
 #define USE_CG 1
@@ -246,5 +247,5 @@
 
 		// mat_specular and mat_shininess are NOT default values
-		GLfloat mat_ambient[] = {0.5f, 0.5f, 0.5f, 1.0f};
+		GLfloat mat_ambient[] = {0.2f, 0.2f, 0.2f, 1.0f};
 		GLfloat mat_diffuse[] = {1.0f, 1.0f, 1.0f, 1.0f};
 		GLfloat mat_specular[] = {0.3f, 0.3f, 0.3f, 1.0f};
@@ -256,14 +257,14 @@
 		glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
 
-		GLfloat light_ambient[] = {0.3, 0.3, 0.3, 1.0};
+		GLfloat light_ambient[] = {0.1, 0.1, 0.1, 1.0};
 		//GLfloat light_diffuse[] = {0.6, 0.6, 0.6, 1.0};
-		GLfloat light_diffuse[] = {0.6, 0.6, 0.6, 1.0};
+		GLfloat light_diffuse[] = {0.5, 0.5, 0.5, 1.0};
 		GLfloat light_specular[] = {1.0, 1.0, 1.0, 1.0};
 
 		glEnable(GL_LIGHTING);
-		//GLfloat light_position[] =  {278.0f, 548.8f,279.0f, 1.0f};
-		//GLfloat light_position[] =  {0.f, 0.f, 0.f, 1.0f};
-		GLfloat light_position[] =  {0.f, 0.0f, 0.f, 1.0f};
-
+		GLfloat light_position[] =  {0.f, 0.f, 0.f, 1.0f};
+
+		// lights in arena
+		
 		glEnable(GL_LIGHT0); 
 
@@ -272,10 +273,12 @@
 		glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
 		glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
-		glLightfv (GL_LIGHT0, GL_POSITION, light_position);
-
+
+		
+		
+		
 		glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
 		glEnable(GL_COLOR_MATERIAL);
 
-		GLfloat lmodel_ambient[] = {0.3f, 0.3f, 0.3f, 1.0f};
+		GLfloat lmodel_ambient[] = {0.1f, 0.1f, 0.1f, 1.0f};
 		glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
 
@@ -466,5 +469,5 @@
 	
 	// mat_specular and mat_shininess are NOT default values
-	GLfloat mat_ambient[] = {0.5f, 0.5f, 0.5f, 1.0f};
+	GLfloat mat_ambient[] = {0.1f, 0.1f, 0.1f, 1.0f};
 	GLfloat mat_diffuse[] = {1.0f, 1.0f, 1.0f, 1.0f};
 	GLfloat mat_specular[] = {0.3f, 0.3f, 0.3f, 1.0f};
@@ -480,10 +483,12 @@
 
 	// a light	
-	GLfloat light_ambient[] = {0.3, 0.3, 0.3, 1.0};
-    GLfloat light_diffuse[] = {0.6, 0.6, 0.6, 1.0};
-    GLfloat light_specular[] = {1.0, 1.0, 1.0, 1.0};
-    GLfloat light_position[] =  {0.f, .0f, 0.f, 1.0f};
+	GLfloat light_ambient[] = {0.05, 0.05, 0.05, 1.0};
+    GLfloat light_diffuse[] = {0.7, 0.7, 0.7, 1.0};
+    GLfloat light_specular[] = {0.3, 0.3, 0.3, 1.0};
+    //GLfloat light_position[] =  {0.f, .0f, 0.f, 1.0f};
     //GLfloat light_position[] =  {600.0f, 250.0f, -500.f, 1.0f};
     //GLfloat light_position[] = {278.0f, 548.8f,279.0f, 1.0f};
+
+
 
 	glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
@@ -491,21 +496,34 @@
 	glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
 
-	glLightfv(GL_LIGHT0, GL_POSITION, light_position);
-
-	//glDisable(GL_LIGHT0);
-	glEnable(GL_LIGHT0);
+	glLightf(GL_LIGHT0, GL_CONSTANT_ATTENUATION, 1);
+	glLightf(GL_LIGHT0, GL_LINEAR_ATTENUATION, 0);
+	glLightf(GL_LIGHT0, GL_QUADRATIC_ATTENUATION, 0);
+	
+	//	GLfloat light1_position[] =  {-22.076887, 21.070816, 50.272095};
+	
+	// GLfloat light1_position[] =  {0, 0, -100};
 
 	glLightfv(GL_LIGHT1, GL_AMBIENT, light_ambient);
 	glLightfv(GL_LIGHT1, GL_DIFFUSE, light_diffuse);
 	glLightfv(GL_LIGHT1, GL_SPECULAR, light_specular);
-		
-	// set position of the light2
-	GLfloat infinite_light2[] = {  -0.3, 1.5, 1.0, 0.0  };
-	glLightfv (GL_LIGHT1, GL_POSITION, infinite_light2);
-	//glEnable(GL_LIGHT1);
-
-	GLfloat lmodel_ambient[] = {0.3f, 0.3f, 0.3f, 1.0f};
+
+	glLightf(GL_LIGHT1, GL_CONSTANT_ATTENUATION, 1.0f);
+	glLightf(GL_LIGHT1, GL_LINEAR_ATTENUATION, 0);
+	glLightf(GL_LIGHT1, GL_QUADRATIC_ATTENUATION, 0);
+
+
+	glLightfv(GL_LIGHT2, GL_AMBIENT, light_ambient);
+	glLightfv(GL_LIGHT2, GL_DIFFUSE, light_diffuse);
+	glLightfv(GL_LIGHT2, GL_SPECULAR, light_specular);
+	
+	
+	glEnable(GL_LIGHT0);
+	glEnable(GL_LIGHT1); 
+	glEnable(GL_LIGHT2); 
+
+	
+	GLfloat lmodel_ambient[] = {0.05f, 0.05f, 0.05f, 1.0f};
 	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
-
+	
 	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
 	//glColorMaterial(GL_FRONT_AND_BACK, GL_SPECULAR);
@@ -732,6 +750,10 @@
 	glStencilOp(GL_KEEP, GL_KEEP, GL_INCR); 
 
+#if TEASER
+	glColor3f(0.0f, 0.8f, 0.0f);
+#else
 	glColor3f(0.6f, 0.6f, 0.6f);
-
+#endif
+	
 	// Render PVS
 	VisualizePvs();
@@ -986,4 +1008,12 @@
 	SetupCameraProjection(width(), height());
 	SetupCamera();
+
+	GLfloat light0_position[] =  {22.495655, 21.070816, -1001.375000};
+	GLfloat light1_position[] =  {-22.076887, 21.070816, -997.272095};
+	GLfloat light2_position[] =  { 0.3, 1.5, -0.3, 0.0  };
+
+	glLightfv (GL_LIGHT0, GL_POSITION, light0_position);
+	glLightfv (GL_LIGHT1, GL_POSITION, light1_position);
+	glLightfv (GL_LIGHT2, GL_POSITION, light2_position);
 
 	if (mRenderErrors) 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2709)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2719)
@@ -97,6 +97,6 @@
 
 		// for sg snapshot
-		mViewPoint = Vector3(32.8596, 9.86079, -1023.79);
-		mViewDirection = Vector3(-0.92196, 0, 0.387286);
+	  mViewPoint = Vector3(32.8596, 9.86079, -1023.79);
+	  mViewDirection = Vector3(-0.92196, 0, 0.387286);
 
 		// inside
@@ -104,4 +104,6 @@
 		mViewDirection = Vector3(-0.604798, 0, 0.796379);
 
+		if (0) {
+
 		// outside
 		mViewPoint = Vector3(35.092, 17.7078, -857.966);
@@ -138,4 +140,5 @@
 		mViewPoint = Vector3(1188.22, 187.427, -381.739);
 		mViewDirection = Vector3(-0.963031, -0, -0.269365);
+		}
 	}
 
@@ -145,6 +148,6 @@
 		                                      mDetectEmptyViewSpace);
 
-	//mSnapErrorFrames = false;
-	mSnapErrorFrames = true;
+	mSnapErrorFrames = false;
+	//mSnapErrorFrames = true;
 
 	mSnapPrefix = "snap/";
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Makefile
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2714)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2719)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (2.00a) (Qt 4.1.2) on: po 26. V 14:55:33 2008
+# Generated by qmake (2.00a) (Qt 4.1.2) on: út 27. V 17:03:19 2008
 # Project:  preprocessor.pro
 # Template: app
Index: GTP/trunk/Lib/Vis/Preprocessing/src/SGA08/run_test_pixel_nemo
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/SGA08/run_test_pixel_nemo	(revision 2719)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/SGA08/run_test_pixel_nemo	(revision 2719)
@@ -0,0 +1,53 @@
+#!/bin/sh
+
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -samples_per_pass=1000000 -samples_per_evaluation=10000000 -total_samples=250000000 -preprocessor_pvs_rendererror_samples=100000 -preprocessor_evaluatePixelError+ -preprocessor_detect_empty_viewspace+ -kd_pvs_area=1e-4 -view_cells_use_kd_pvs+ -af_use_kd_pvs+ -view_cells_import_random_viewcells+ -view_cells_export_random_viewcells- -preprocessor_ray_cast_method=1 -preprocessor_use_vbos+"
+ 
+
+#SCENE=../data/PowerPlant/selection.plb
+#VIEWCELLS=../data/PowerPlant/power_plant_viewcells1.xml
+
+#SCENE=../data/vienna/vienna_cropped.obj
+#VIEWCELLS=../data/vienna/vienna_cropped-gradient-viewcells.xml.gz
+# view cells used for pixel error measurement
+#VIEWCELLS=../data/vienna/vienna-seq-viewcells-20000.xml.gz
+
+# #SCENE=../data/Arena/arena-high-lods.obj
+# #VIEWCELLS=../data/Arena/arena-high-lods-5000-viewcells.xml.gz
+# VIEWPOINTS=../data/Arena/arena_key.vp
+# PREFIX=../work/plots/SGA08-arena-pixel
+
+SCENE=../data/vienna/city_full_hp.obj
+VIEWCELLS=../data/vienna/vienna_cropped-gradient-viewcells.xml.gz
+VIEWPOINTS=../data/vienna/testwalk.vp
+PREFIX=../work/plots/SGA08-vienna_full_hp-pixel
+
+
+$COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-preprocessor_visibility_file=$PREFIX-r-reference.xml \
+-view_cells_random_viewpoint_list=$VIEWPOINTS \
+-view_cells_filter_max_size=1 -preprocessor_stats=$PREFIX-refu.log \
+-preprocessor_histogram_file=$PREFIX-refu.hlog
+
+$COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+ -rss_distributions=direction -view_cells_filter_max_size=1 \
+ -view_cells_random_viewpoint_list=$VIEWPOINTS \
+ -preprocessor_visibility_file=$PREFIX-spgvu.xml \
+ -preprocessor_stats=$PREFIX-spgvu.log \
+ -preprocessor_histogram_file=$PREFIX-spgvu.hlog
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
+-preprocessor_evaluate_filter- \
+ -view_cells_random_viewpoint_list=$VIEWPOINTS \
+-preprocessor_visibility_file=$PREFIX-pgv.xml \
+-preprocessor_stats=$PREFIX-pgv.log \
+-preprocessor_histogram_file=$PREFIX-pgv.hlog
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
+-preprocessor_evaluate_filter+ \
+-view_cells_random_viewpoint_list=$VIEWPOINTS \
+-preprocessor_visibility_file=$PREFIX-pgvf.xml \
+-preprocessor_stats=$PREFIX-pgvf.log \
+-preprocessor_histogram_file=$PREFIX-pgvf.hlog
+
Index: GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2708)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2719)
@@ -86,5 +86,5 @@
 }
 
-QMAKE_LFLAGS_CONSOLE=/NODEFAULTLIB:LIBCMT
+QMAKE_LFLAGS_CONSOLE=/NODEFAULTLIB:LIBCMT /DEBUG
 
 CONFIG(qt) {